/* global define, require */
define('WS.Data/Chain/Generator', [
   'WS.Data/Chain/Abstract'
], function (
   Abstract
) {
   'use strict';

   /**
    * Цепочка по генератору.
    * @class WS.Data/Chain/Generator
    * @extends WS.Data/Chain/Abstract
    * @public
    * @author Мальцев Алексей
    */

   var Generator = Abstract.extend(/** @lends WS.Data/Chain/Generator.prototype */{
      '[WS.Data/Chain/Generator]': true,

      constructor: function Generator(source) {
         Generator.superclass.constructor.call(this, source);
         throw new Error('Under construction');
      }
   });

   return Generator;
});
