/* global define */
define('WS.Data/Format/BinaryField', [
   'WS.Data/Format/Field'
], function (
   Field
) {
   'use strict';

   /**
    * Формат двоичного поля.
    *
    * Создадим поле двоичного типа:
    * <pre>
    *    var field = {
    *       name: 'foo',
    *       type: 'binary'
    *    };
    * </pre>
    * @class WS.Data/Format/BinaryField
    * @extends WS.Data/Format/Field
    * @public
    * @author Мальцев Алексей
    */

   var BinaryField = Field.extend(/** @lends WS.Data/Format/BinaryField.prototype */{
      '[WS.Data/Format/BinaryField]': true

      //region Public methods

      //endregion Public methods

   });

   return BinaryField;
});
