/* global define */
define('WS.Data/Format/RecordSetField', [
   'WS.Data/Format/Field'
], function (
   Field
) {
   'use strict';

   /**
    * Формат поля для рекордсета.
    *
    * Создадим поле c типом "Рекордсет":
    * <pre>
    *    var field = {
    *       name: 'foo',
    *       type: 'recordset'
    *    };
    * </pre>
    * @class WS.Data/Format/RecordSetField
    * @extends WS.Data/Format/Field
    * @public
    * @author Мальцев Алексей
    */

   var RecordSetField = Field.extend(/** @lends WS.Data/Format/RecordSetField.prototype */{
      '[WS.Data/Format/RecordSetField]': true

      //region Public methods
      //endregion Public methods
   });

   return RecordSetField;
});
