define('Core/app-init',
[
   'Core/load-contents',
   'Core/core-merge',
   'Core/constants',
   'Core/polyfill',
   'Core/patchRequireJS'
], function(
   loadContents,
   cMerge,
   _const,
   pf,
   patchRequireJS
) {
   "use strict";
   patchRequireJS();

   function filterNone() {
      return NodeFilter.FILTER_ACCEPT;
   }

   function getAllComments(rootElem) {
      var comments = [];
      // Fourth argument, which is actually obsolete according to the DOM4 standard, is required in IE 11
      var iterator = document.createNodeIterator(rootElem, NodeFilter.SHOW_COMMENT, filterNone, false);
      var curNode = iterator.nextNode();
      while (curNode) {
         comments.push(curNode);
         curNode = iterator.nextNode();
      }
      return comments;
   }

   return function() {
      cMerge(_const, window.wsConfig || {}, { rec: false });

      //TODO: убрать этот костыль когда Дима пофиксит ошибку https://online.sbis.ru/opendoc.html?guid=a7c9a632-f24e-44e2-9a53-285879d789b1
      getAllComments(document.body).forEach(function(elem) {
         elem.parentNode.removeChild(elem);
      });


      loadContents(window.contents, false, {
         resources: wsConfig.resourceRoot
      });
   };
});