define('Core/app-start', [
   'Core/Control'
], function(Control) {
   'use strict';

   return function(config) {
      var dom = document.getElementById('root');
      requirejs([dom.attributes["component"].value], function(result) {
         var configReady = config||{};
         if (typeof window && window.wsConfig){
            for (var i in window.wsConfig){
               if (window.wsConfig.hasOwnProperty(i)) {
                  configReady[i] = window.wsConfig[i];
               }
            }
         }
         var _getChildContext = result.prototype._getChildContext;
         result.prototype._getChildContext = function(){
            var base = _getChildContext?_getChildContext():{};
            if (typeof window && window.startContextData){
               for (var i in window.startContextData){
                  if (window.startContextData.hasOwnProperty(i)) {
                     base[i] = window.startContextData[i];
                  }
               }
            }
            return base;
         };
         Control.createControl(result, configReady, dom);
      });
   };
});