define('Core/apply-contents', [
   'Core/load-contents',
   'Core/helpers/Object/isEmpty',
   'Core/constants'
], function(
   loadContents,
   isEmptyObject,
   _const
) {
   var global = (function() { return this || (0, eval)('this'); })();

   if (global.contents && !isEmptyObject(global.contents)) {
      loadContents(global.contents, false, {
         resources: _const.resourceRoot
      });
   }
});
