/**
 * Created by dv.zuev on 10.10.2017.
 */
define('Core/vdom/Synchronizer/resources/DirtyCheckingCompatible',
   [
      'View/Runner/expressions/compatible',
      'View/Runner/tclosure'
   ], function(compatibleHelpers,
               tclosure){


   return {
      createCompoundControlNode: function createCompoundControlNode(controlClass_, controlCnstr, userOptions, internalOptions, key, parentNode, vnode){
         return compatibleHelpers.createCompoundControlNode(
            controlClass_, controlCnstr, [], // вложенные v-ноды (их нет у только что созданного контрола)
            userOptions, internalOptions, key, parentNode, vnode, tclosure.getMarkupGenerator(false)
         );

      },
      clearNotChangedOptions: function(options){
         if (options) {
            delete options.editingTemplate;
            delete options.columns;
            delete options.itemContentTpl;
            delete options.dictionaries;
         }
         return options;
      }
   };

});