/* Russian (UTF-8) initialisation for the jQuery UI date picker plugin. */
define('Deprecated/Controls/FieldDate/resources/ext/jquery.ui.datepicker-local', [
   'Core/i18n',
   'is!browser?cdn!jquery-ui/1.8.9/jquery-ui-1.8.5.2.custom.min.js'
], function(i18n) {
   // Для английского языка ничего не надо переопределять
   var currentLang = i18n.getLang();
   if (currentLang.substr(0,2) == 'en') {
      return;
   }

   jQuery(function($){
      $.datepicker.regional['ru'] = {
         closeText: 'Закрыть',
         prevText: '&#x3c;Пред',
         nextText: 'След&#x3e;',
         currentText: 'Сегодня',
         monthNames: [
            'Январь', 'Февраль', 'Март', 'Апрель', 'Май', 'Июнь',
            'Июль', 'Август', 'Сентябрь', 'Октябрь', 'Ноябрь', 'Декабрь'
         ],
         monthNamesShort: [
            'Янв', 'Фев', 'Мар', 'Апр', 'Май', 'Июн',
            'Июл', 'Авг', 'Сен', 'Окт', 'Ноя', 'Дек'
         ],
         dayNames: ['воскресенье','понедельник','вторник','среда','четверг','пятница','суббота'],
         dayNamesShort: ['вск','пнд','втр','срд','чтв','птн','сбт'],
         dayNamesMin: ['Вс','Пн','Вт','Ср','Чт','Пт','Сб'],
         weekHeader: 'Не',
         dateFormat: 'dd.mm.yy',
         firstDay: 1,
         isRTL: false,
         showMonthAfterYear: false,
         yearSuffix: ''
      };
      $.datepicker.setDefaults($.datepicker.regional['ru']);
   });
});
