/**
 * Created with JetBrains PhpStorm.
 * User: tm.baeva
 * Date: 21.04.13
 * Time: 20:16
 * To change this template use File | Settings | File Templates.
 */
define('Deprecated/Controls/FieldInteger/FieldInteger', ['Deprecated/Controls/FieldNumeric/FieldNumeric'], function(FieldNumeric) {

   'use strict';

   /**
    * Поле ввода целочисленных значений
    * @class Deprecated/Controls/FieldInteger/FieldInteger
    * @extends Deprecated/Controls/FieldNumeric/FieldNumeric
    * @author Крайнов Д.О.
    * @control
    * @public
    * @initial
    * <component data-component='Deprecated/Controls/FieldInteger/FieldInteger' style='width: 100px'>
    * </component>
    * @category Fields
    * @designTime actions Deprecated/Controls/FieldString/design/design
    * @ignoreOptions decimals
    * @ignoreOptions hideEmptyDecimals
    * @ignoreOptions showEmptyDecimalsOnFocus
    * @deprecated Используйте класс {@link SBIS3.CONTROLS.NumberTextBox}.
    */
   var FieldInteger = FieldNumeric.extend(/** @lends Deprecated/Controls/FieldInteger/FieldInteger.prototype */{
      $protected : {
         _options : {
            cssClass: 'ws-field-numeric ws-field-integer'
         }
      },
      /**
       * Обработка целочисленного значения
       * @param {String} value входное значение
       * @returns {String} value обработанное значение на выходе
       * @protected
       */
      _valueInternalProcessing: function(value){
         var
            v = value + '',
            dotPos = v.indexOf('.');
         if (dotPos !== -1) {
            v = v.substr(0, dotPos);
         }
         if (v === 'null') {
            v = '';
         }
         return FieldInteger.superclass._valueInternalProcessing.apply(this, [v]);
      }
   });

   return FieldInteger;

});