define('Deprecated/Controls/NavigationPanel/plugins/Collapse-plugin', [
   "Deprecated/Controls/NavigationPanel/NavigationPanel",
   "Lib/CollapsingNavigation/CollapsingNavigation"
],
      function (NavigationPanel, CollapsingNavigation) {

         'use strict';

          NavigationPanel.CollapsePlugin = NavigationPanel.extendPlugin($.extend({}, CollapsingNavigation, {
            _initCollapsingNavigation: function () {
               var data = this._roots.map(function (value) {
                  return {
                     id: value,
                     title: this._recordSet.getRecordByPrimaryKey(value).get(this._options.altTreeNameFld)
                  };
               }, this);
               CollapsingNavigation._initCollapsingNavigation.call(this, data);
            },
            _getActiveLabelId: function () {
               var
                     activeRecord = this.getActiveRecord(),
                     pKey;
               while ((pKey = activeRecord.getParentKey())) {
                  activeRecord = this._recordSet.getRecordByPrimaryKey(pKey);
               }
               return activeRecord.getKey();
            },
            _positioningMarker: function () {
               this._onReplaceMarkerHandler(this._getActiveLabelId());
            }
         }));
      });