define('Deprecated/JSONLoader', [
   'Core/core-extend',
   'Core/constants',
   'Core/IoC'
], function(coreExtend, constants, ioc) {
   var JSONLoader;
   /**
    * @class Deprecated/JSONLoader
    * @author Бегунов А.В.
    * @public
    * @deprecated
    */
   JSONLoader = coreExtend({}, /** @lends Deprecated/JSONLoader.prototype */{
      $protected: {
         _options: {
            url: '/data.php',
            updateURL: '',
            destroyURL: '',
            tableName: ''
         }
      },
      /**
       * Инициирует загрузку данных
       * @param {Object} arguments
       * @param {String} action выполняемая операция: чтение, редактирование, удаление
       * @returns {Core/Deferred}
       */
      load: function(args, action){
         var url = this._options.url;
         if(action === "update" && this._options.updateURL)
            url =  this._options.updateURL;
         else if(action === "destroy" && this._options.destroyURL)
            url =  this._options.destroyURL;
         if(this._options.tableName !== '')
            args["tableName"] = this._options.tableName;
         return ioc.resolve('ITransport', {
            method: 'POST',
            dataType: 'json',
            url: url + (/\?/.test(url) ? "&" : "?") + "$=1"
         }).execute(args);
      }
   });

   return JSONLoader;
});