/**
 * Модуль "Диалог выбора изображения с камеры".
 * @description
 */
define('Lib/Control/FileCamLoader/resources/CameraWindow/CameraWindow', [
   'Lib/Control/CompoundControl/CompoundControl',
   'html!Lib/Control/FileCamLoader/resources/CameraWindow/CameraWindow',
   'Deprecated/Controls/Button/Button',
   'Deprecated/Controls/CloseButton/CloseButton',
   'css!Lib/Control/FileCamLoader/resources/CameraWindow/CameraWindow',
   'i18n!Lib/Control/FileCamLoader/FileCamLoader'
], function(CompoundControl, dotTplFn) {

   var Dialog;
   Dialog = CompoundControl.extend({
      _dotTplFn: dotTplFn,
      _closeButton__onActivated: function () {
         this.getTopParent().close(false);
      },
      _loadButton__onActivated: function () {
         this.getTopParent().close(true);
      }
   });

   Dialog.dimensions = { width: 640, height: 480};

   return Dialog;
});