/// <amd-module name="Lib/File/Attach/Option/Getters/Clipboard" />
define("Lib/File/Attach/Option/Getters/Clipboard", ["require", "exports", "tslib", "Lib/File/Attach/Option/ResourceGetter"], function (require, exports, tslib_1, ResourceGetter) {
    "use strict";
    var GETTER_LINK = "js!SBIS3.Plugin/components/Extensions/Integration/FileGetter/ClipboardGetter";
    var GETTER_TYPE = "ClipboardGetter";
    /**
     * Класс конфигурации IResourceGetter для получения файлов из буфера обмена, передаваемый в SbisAttach
     * @class
     * @name Lib/File/Attach/Option/Getters/Clipboard
     * @public
     * @author Заляев А.В.
     */
    var Clipboard = /** @class */ (function (_super) {
        tslib_1.__extends(Clipboard, _super); /** @lends Lib/File/Attach/Option/Getters/Clipboard.prototype*/
        /**
         * @param {*} [options] Параметры вызова конструктора
         * @constructor
         * @see Lib/File/ResourceGetter/IResourceGetterBase
         */
        function Clipboard(options) {
            return _super.call(this, GETTER_LINK, GETTER_TYPE, options || {}) || this;
        }
        return Clipboard;
    }(ResourceGetter /** @lends Lib/File/Attach/Option/Getters/Clipboard.prototype*/));
    return Clipboard;
});
