/// <amd-module name="Lib/File/Attach/Option/Getters/Clipboard" />

import ResourceGetter = require("Lib/File/Attach/Option/ResourceGetter");

const GETTER_LINK = "js!SBIS3.Plugin/components/Extensions/Integration/FileGetter/ClipboardGetter";
const GETTER_TYPE = "ClipboardGetter";

/**
 * Класс конфигурации IResourceGetter для получения файлов из буфера обмена, передаваемый в SbisAttach
 * @class
 * @name Lib/File/Attach/Option/Getters/Clipboard
 * @public
 * @author Заляев А.В.
 */
class Clipboard extends ResourceGetter /** @lends Lib/File/Attach/Option/Getters/Clipboard.prototype*/{
    /**
     * @param {*} [options] Параметры вызова конструктора
     * @constructor
     * @see Lib/File/ResourceGetter/IResourceGetterBase
     */
    constructor (options?: any) {
        super (GETTER_LINK, GETTER_TYPE, options || {});
    }
}
export = Clipboard;