/// <amd-module name="Lib/File/Attach/Option/Getters/Dialogs" />

import ResourceGetter = require("Lib/File/Attach/Option/ResourceGetter");

const GETTER_LINK = "js!SBIS3.Plugin/components/Extensions/Integration/FileGetter/DialogsGetter";
const GETTER_TYPE = "DialogsGetter";

/**
 * Класс конфигурации IResourceGetter для получения файлов из диалогового окна СБИС Плагина, передаваемый в SbisAttach
 * @class
 * @name Lib/File/Attach/Option/Getters/Dialogs
 * @public
 * @author Заляев А.В.
 */
class Dialogs extends ResourceGetter /** @lends Lib/File/Attach/Option/Getters/Dialogs.prototype*/{
    /**
     * @param {*} [options] Параметры вызова конструктора
     * @constructor
     * @see Lib/File/ResourceGetter/IResourceGetterBase
     */
    constructor (options?: any) {
        super (GETTER_LINK, GETTER_TYPE, options || {});
    }
}
export = Dialogs;