/// <amd-module name="Lib/File/Attach/Option/Getters/PhotoCam" />
define("Lib/File/Attach/Option/Getters/PhotoCam", ["require", "exports", "tslib", "Lib/File/Attach/Option/ResourceGetter"], function (require, exports, tslib_1, ResourceGetter) {
    "use strict";
    var GETTER_LINK = "Lib/File/ResourceGetter/PhotoCam";
    var GETTER_TYPE = "PhotoCam";
    /**
     * Класс конфигурации IResourceGetter для получения снимков с камеры, передаваемый в SbisAttach
     * @class
     * @name Lib/File/Attach/Option/Getters/PhotoCam
     * @public
     * @author Заляев А.В.
     */
    var PhotoCam = /** @class */ (function (_super) {
        tslib_1.__extends(PhotoCam, _super); /** @lends Lib/File/Attach/Option/Getters/PhotoCam.prototype*/
        /**
         * @param {*} [options] Параметры вызова конструктора
         * @constructor
         * @see Lib/File/ResourceGetter/IResourceGetterBase
         */
        function PhotoCam(options) {
            return _super.call(this, GETTER_LINK, GETTER_TYPE, options || {}) || this;
        }
        return PhotoCam;
    }(ResourceGetter /** @lends Lib/File/Attach/Option/Getters/PhotoCam.prototype*/));
    return PhotoCam;
});
