/// <amd-module name="Lib/File/Attach/Option/Getters/Scanner" />

import ResourceGetter = require("Lib/File/Attach/Option/ResourceGetter");

const GETTER_LINK = "js!SBIS3.Plugin/components/Extensions/Integration/FileGetter/ScannerGetter";
const GETTER_TYPE = "ScannerGetter";

/**
 * Класс конфигурации IResourceGetter для получения сканов, передаваемый в SbisAttach
 * @class
 * @name Lib/File/Attach/Option/Getters/Scanner
 * @public
 * @author Заляев А.В.
 */
class Scanner extends ResourceGetter /** @lends Lib/File/Attach/Option/Getters/Scanner.prototype*/{
    /**
     * @param {*} [options] Параметры вызова конструктора
     * @constructor
     * @see Lib/File/ResourceGetter/IResourceGetterBase
     */
    constructor (options?: any) {
        super (GETTER_LINK, GETTER_TYPE, options || {});
    }
}
export = Scanner;