/// <amd-module name="Lib/File/Attach/Option/Sources/FileTransferPlugin" />
define("Lib/File/Attach/Option/Sources/FileTransferPlugin", ["require", "exports", "tslib", "Lib/File/Attach/Option/Source", "Lib/File/LocalFileLink"], function (require, exports, tslib_1, SourceOption, LocalFileLink) {
    "use strict";
    var LINK = "js!SBIS3.Plugin/components/Extensions/Integration/Source/FileTransfer_SbisPluginSource";
    /**
     * Класс конфигурации ISource для загрузки на FileTransfer через СБИС Плагин
     * @class
     * @name Lib/File/Attach/Option/Sources/FileTransferPlugin
     * @public
     * @author Заляев А.В.
     */
    var FileTransferPlugin = /** @class */ (function (_super) {
        tslib_1.__extends(FileTransferPlugin, _super); /** @lends Lib/File/Attach/Option/Sources/FileTransferPlugin.prototype*/
        /**
         * @param {*} [options] Параметры вызова конструктора
         * @constructor
         * @see Lib/File/LocalFileLink
         * @see WS.Data/Source/ISource
         */
        function FileTransferPlugin(options) {
            return _super.call(this, LINK, LocalFileLink, options || {}) || this;
        }
        return FileTransferPlugin;
    }(SourceOption /** @lends Lib/File/Attach/Option/Sources/FileTransferPlugin.prototype*/));
    return FileTransferPlugin;
});
