define("Lib/ServerEvent/class/creator/CreatorWebSocket", ["require", "exports", "tslib", "Core/moduleStubs", "Lib/ServerEvent/class/creator/CreatorLocalWebSocket"], function (require, exports, tslib_1, moduleStubs, CreatorLocalWebSocket) {
    "use strict";
    /**
     * @class {Lib/ServerEvent/class/creator/CreatorLocalWebSocket}
     */
    var CreatorWebSocket = /** @class */ (function (_super) {
        tslib_1.__extends(CreatorWebSocket, _super);
        function CreatorWebSocket() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        CreatorWebSocket.prototype.getWebSocket = function (url) {
            return moduleStubs.require("Lib/ServerEvent/native/SockjsEmulator").addCallback(function (_a) {
                var SockJSTransport = _a[0];
                return new SockJSTransport(url);
            }).createDependent();
        };
        CreatorWebSocket.prototype.getResources = function () {
            return moduleStubs.require("Lib/ServerEvent/resources/stomp");
        };
        return CreatorWebSocket;
    }(CreatorLocalWebSocket));
    return CreatorWebSocket;
});
