/// <amd-module name="Lib/ServerEvent/class/logger/ConsoleWatchDog" />
/**
 * @author Санников К.А.
 */
"use strict";
import {SEB} from "../../interfaces";

class ConsoleWatchDog implements SEB.IWatchDog {
    logStomp(message: SEB.StompMessageData) {
        console.log('[STOMP]', message);
    }

    logEvent(channelName: string, eventName: string, data: any) {
        console.log(`[ServerEvent][${channelName}][${eventName}]`, data);
    }
}

export = ConsoleWatchDog;