import Writer = require('Lib/ServerEvent/native/EventStorage/Writer');
import Reader = require('Lib/ServerEvent/native/EventStorage/Reader');
import Deferred = require('Core/Deferred');
/**
 * Создан для соединения по IE
 * @class Lib/ServerEvent/native/EventStorage/ConnectorIE
 */
declare class ConnectorIE {
    private db;
    static DB_NAME: string;
    static STORE_NAME: string;
    /**
     * @param {Core/Deferred} def
     * @return {Core/Deferred<ConnectorIE>}
     */
    static connect(): Deferred<ConnectorIE>;
    constructor(db: IDBDatabase);
    /**
     * @return {Lib/ServerEvent/native/EventStorage/Writer}
     */
    getWriter(): Writer;
    /**
     * @return {Lib/ServerEvent/native/EventStorage/Reader}
     */
    getReader(): Reader;
}
export = ConnectorIE;
