/// <reference path="../../resources/stomp.d.ts" />
/**
 * Класс, который записывает Stomp данные в IndexDB
 * @class Lib/ServerEvent/native/EventStorage/Writer
 * @memberOf module:ServerEvent.native.EventStorage
 */
declare class Writer {
    private db;
    private storeName;
    static GC_INTERVAL: number;
    static STORE_KEY: string;
    static GC_EVENT_LIMIT: number;
    /** @constructor */
    constructor(db: IDBDatabase, storeName: string);
    write(message: Stomp.Message): void;
    createStore(): void;
    private garbageCollection();
}
export = Writer;
