/**
 * Created by dv.zuev on 07.08.2017.
 */
define('js!WSTests/unit/tmpl/sync-tests/context/skipContextTop', [
   'Core/Control',
   'tmpl!WSTests/unit/tmpl/sync-tests/context/skipContextTop',
   'js!WSTests/unit/tmpl/sync-tests/context/contextField'
], function (Control, tmpl, contextField) {
   'use strict';

   var testModule = Control.extend({
      _template: tmpl,
      ctxValue: null,
      constructor: function(cfg) {
         this.ctxValue = new contextField();
         testModule.superclass.constructor.call(this, cfg);
      },
      _getChildContext: function(){
         return { topField: this.ctxValue };
      },
      setContextValue: function() {
         this.ctxValue.setData();
         $('.midControl')[0].controlNodes[0].control.setContextValue();
         this._forceUpdate();
      }
   });

   return testModule;
});
