define('js!WSTests/unit/tmpl/sync-tests/coupPiledAsync', [
   'Core/Control',
   'tmpl!WSTests/unit/tmpl/sync-tests/coupPiledAsync',
   'Core/Deferred'
], function (Control, tmpl, Deferred) {
   'use strict';

   var testModule = Control.extend({
      _template: tmpl,
      text: 'root async test',
      _beforeMount: function (options) {
         var def = new Deferred();
         setTimeout(function () {
            def.callback({
               cherry: 'pie'
            });
         }, 100);
         return def;
      }
   });

   return testModule;
});
