/**
 * Created by dv.zuev on 07.08.2017.
 */
define('js!WSTests/unit/tmpl/sync-tests/eventHandlerDeferred/eventHandlerDeferredMid', [
   'Core/Control',
   'tmpl!WSTests/unit/tmpl/sync-tests/eventHandlerDeferred/eventHandlerDeferredMid',
   'Core/Deferred'
], function (Control, tmpl, Deferred) {
   'use strict';

   var testModule = Control.extend({
      text: 'init text',
      sdCalled: false,
      _template: tmpl,
      onChildEvent: function() {
         var def = new Deferred().addCallback(function() {
            this.text = 'event handled!!!';
         }.bind(this));
         setTimeout(function() {
            def.callback();
         }, 100);
         return def;
      }

   });

   return testModule;
});
