/**
 * Created by dv.zuev on 07.08.2017.
 */
define('js!WSTests/unit/tmpl/sync-tests/for-with-control', [
   'Core/Control',
   'tmpl!WSTests/unit/tmpl/sync-tests/for-with-control'
], function (Control, tmpl) {
   'use strict';

   var testModule = Control.extend({
      _template: tmpl,
      data: null,
      count: 0,
      blockUpdate: false,
      _beforeMount: function(newOptions){
         this.data = newOptions.data;
      },
      setNewData: function(newData){
         this.data = newData;
         this._forceUpdate();
      },
      calcUpdated: function(){
         var k = 0, j = 0;
         for(var i in this._children){
            if (i === 'get' || i==='has'){
               continue;
            }
            if (this._children[i].updated &&
               this._children[i]._options.title === this.data[j].title){
               k++;
            }
            j++;
         }
         return k;
      }
   });

   return testModule;
});
