/**
 * Created by dv.zuev on 10.08.2017.
 */
define('js!WSTests/unit/tmpl/sync-tests/life', [
   'js!WSTests/unit/tmpl/sync-tests/oneDiv',
   'tmpl!WSTests/unit/tmpl/sync-tests/oneDiv'
], function (Control, tmpl) {
   'use strict';

   var testModule = Control.extend({
      _template: tmpl,
      constructorGood: false,
      _beforeMountGood: false,
      _afterMountGood: false,
      constructor: function (cfg) {
         testModule.superclass.constructor.call(this, cfg);
         this.constructorGood = true;
         for(var i in this._options){
            this.constructorGood = false;
         }
      },

      _beforeMount: function(options){
         if (this._options.testOption === undefined && options.testOption === true) {
            this._beforeMountGood = true;
         }
      },

      _afterMount: function(){
         if (this._options.testOption) {
            this._afterMountGood = true;
         }
      }
   });

   return testModule;
});
