/**
 * Created by dv.zuev on 07.08.2017.
 */
define('js!WSTests/unit/tmpl/sync-tests/oneDivAttr', [
   'Core/Control',
   'tmpl!WSTests/unit/tmpl/sync-tests/oneDivAttr'
], function (Control, tmpl) {
   'use strict';

   var testModule = Control.extend({
      _template: tmpl,
      text: '',
      updated: false,
      clicked: false,
      constructor: function(cfg){
         testModule.superclass.constructor.call(this, cfg);
      },
      onMouseClick: function (e) {
         this.clicked = true;
         this.text = 'text';
         this._notify('onChangeText', this.text);
         this._forceUpdate();
      },

      _beforeUpdate: function(){
         this.updated = true;
      }
   });

   return testModule;
});
