/**
 * Test control
 * controlNodes: [c5, c4, c3, c2, c1]
 * eventProperties: [f5, f2, f1]
 * c4 notifies custom event
 * f2, f1 should handle event
 * Created by dv.zuev on 07.08.2017.
 */
define('js!WSTests/unit/tmpl/sync-tests/vdomEvents/multipleControlNodes2/multipleControlNodes1', [
   'Core/Control',
   'tmpl!WSTests/unit/tmpl/sync-tests/vdomEvents/multipleControlNodes2/multipleControlNodes1'
], function (Control, tmpl) {
   'use strict';

   var testModule = Control.extend({
      _template: tmpl,
      text: '',
      myCustomEvent1: function(event, text) {
         this.text = text;
      }
   });

   return testModule;
});
