var
   buildNumber = process.argv[2],
   fs = require('fs');

function changeBuild(build, cb){
   fs.readFile('./package.json', 'utf8', function(err, file){
      if (err){
         cb(err);
      }
      else{
         file = file.replace('BUILD', build);
         fs.writeFile('./package.json', file, cb);
      }
   });
}

if (buildNumber){
   changeBuild(buildNumber, function(err){
      if (err){
         console.error(err);
      }
      process.exit(1);
   })
}