/* global define */
define('WS.Data/Format/BooleanField', [
   'WS.Data/Format/Field'
], function (
   Field
) {
   'use strict';

   /**
    * Формат логического поля.
    *
    * Создадим поле логического типа:
    * <pre>
    *    var field = {
    *       name: 'foo',
    *       type: 'boolean'
    *    };
    * </pre>
    * @class WS.Data/Format/BooleanField
    * @extends WS.Data/Format/Field
    * @public
    * @author Мальцев Алексей
    */

   var BooleanField = Field.extend(/** @lends WS.Data/Format/BooleanField.prototype */{
      '[WS.Data/Format/BooleanField]': true

      //region Public methods

      //endregion Public methods

   });

   return BooleanField;
});
