/* global define */
define('WS.Data/Format/FlagsField', [
   'WS.Data/Format/DictionaryField'
], function (
   DictionaryField
) {
   'use strict';

   /**
    * Формат поля флагов.
    *
    * Создадим поле c типом "Флаги":
    * <pre>
    *    var field = {
    *       name: 'foo',
    *       type: 'flags',
    *       dictionary: ['one', 'two', 'three']
    *    };
    * </pre>
    * @class WS.Data/Format/FlagsField
    * @extends WS.Data/Format/DictionaryField
    * @public
    * @author Мальцев Алексей
    */

   var FlagsField = DictionaryField.extend(/** @lends WS.Data/Format/FlagsField.prototype */{
      '[WS.Data/Format/FlagsField]': true

      //region Public methods

      //endregion Public methods

   });

   return FlagsField;
});
