/* global define */
define('WS.Data/Format/IntegerField', [
   'WS.Data/Format/Field'
], function (
   Field
) {
   'use strict';

   /**
    * Формат целочисленного поля.
    *
    * Создадим поле челочисленного типа:
    * <pre>
    *    var field = {
    *       name: 'foo',
    *       type: 'integer'
    *    };
    * </pre>
    * @class WS.Data/Format/IntegerField
    * @extends WS.Data/Format/Field
    * @public
    * @author Мальцев Алексей
    */

   var IntegerField = Field.extend(/** @lends WS.Data/Format/IntegerField.prototype */{
      '[WS.Data/Format/IntegerField]': true,

      /**
       * @cfg {Number} Значение поля по умолчанию
       * @name WS.Data/Format/IntegerField#defaultValue
       * @see getDefaultValue
       * @see setDefaultValue
       */
      _$defaultValue: 0

      //region Public methods

      //endregion Public methods

   });

   return IntegerField;
});
