/* global define */
define('WS.Data/Format/RecordField', [
   'WS.Data/Format/Field'
], function (
   Field
) {
   'use strict';

   /**
    * Формат поля для записи.
    *
    * Создадим поле c типом "Запись":
    * <pre>
    *    var field = {
    *       name: 'foo',
    *       type: 'record'
    *    };
    * </pre>
    * @class WS.Data/Format/RecordField
    * @extends WS.Data/Format/Field
    * @public
    * @author Мальцев Алексей
    */

   var RecordField = Field.extend(/** @lends WS.Data/Format/RecordField.prototype */{
      '[WS.Data/Format/RecordField]': true

      //region Public methods

      //endregion Public methods

   });

   return RecordField;
});
