/* global define */
define('WS.Data/Source/Provider/IChannel', function () {
   'use strict';

   /**
    * Интерфейс канала серверных событий
    * @interface WS.Data/Source/Provider/IChannel
    * @public
    * @author Мальцев Алексей
    */

   return /** @lends WS.Data/Source/Provider/IChannel.prototype */{
      '[WS.Data/Source/Provider/IChannel]': true

      /**
       * @event onMessage При получении уведомления о серверном событии
       * @param {Core/EventObject} event Дескриптор события.
       * @param {String|Object} message Сообщение события.
       */
   };
});
