define('Core/helpers/String/escapeHtml', function () {

    /**
     * Модуль, в котором описана функция <b>escapeHtml(str)</b>, которая производит экранирование HTML-тэгов в строке.
     * Функция возвращает экранированную строку.
     *
     * @class Core/helpers/String/escapeHtml
     * @public
     * @author Мальцев А.А.
     */


    return function (str) {
        if (typeof str == "string") {
            return str.replace(/</g, '&lt;').replace(/>/g, '&gt;').replace(/"/g, '&quot;');
        }
        else
            return str;
    };
});