define('Core/helpers/String/unEscapeHtml', function () {
    /**
     * Модуль, в котором описана функция <b>unEscapeHtml(str)</b>, в котором описана функция <b>unEscapeHtml(str)</b>, которая производит разэкранирование HTML тэгов.
     *
     * @class Core/helpers/String/unEscapeHtml
     * @public
     * @author Мальцев А.А.
     */

    //FieldLink, Control
    return function (str) {
        if (typeof str == "string")
            return str.replace(/&lt;/g, '<').replace(/&gt;/g, '>').replace(/&quot;/g, '"').replace(/&amp;/g, '&');
        else
            return str;
    };
});