define('Core/helpers/helpers', [
    'Core/helpers/unrelated-helpers',
    'Core/helpers/collection-helpers',
    'Core/helpers/markup-helpers',
    'Core/helpers/functional-helpers',
    'Core/helpers/date-helpers',
    'Core/helpers/dom&controls-helpers',
    'Core/helpers/fast-control-helpers',
    'Core/helpers/generate-helpers',
    'Core/helpers/string-helpers',
    'Core/helpers/transport-helpers',
    'Core/helpers/event-helpers',
    'Core/helpers/additional-helpers',
    'Deprecated/helpers/additional-helpers',
    'Core/core-debug',
    'Core/core-instance',
    'Core/deprecated'
], function (
    unrelated,
    colHelpers,
    mkupHelpers,
    fHelpers,
    dateHelpers,
    domControlsHelpers,
    fastHelpers,
    genHelpers,
    strHelpers,
    transHelpers,
    eventHelpers,
    addHelpers,
    dAddHelpers,
    cDebug,
    cInstance,
   deprecated
) {
   deprecated.showInfoLog('Core/helpers/helpers помечен как deprecated и будет удален в 3.18. Подключите только необходимые модули хелперов.');
   /**
    * Класс вспомогательных функций веб-фреймворка WS. Он включает в себя функции следующих классов:
    * {@link Core/helpers/unrelated-helpers},
    * {@link Core/helpers/collection-helpers},
    * {@link Core/helpers/markup-helpers},
    * {@link Core/helpers/functional-helpers},
    * {@link Core/helpers/date-helpers},
    * {@link Core/helpers/dom&controls-helpers},
    * {@link Core/helpers/fast-control-helpers},
    * {@link Core/helpers/generate-helpers},
    * {@link Core/helpers/string-helpers},
    * {@link Core/helpers/transport-helpers},
    * {@link Core/helpers/event-helpers},
    * {@link Core/helpers/additional-helpers}
    * и
    * {@link Deprecated/helpers/additional-helpers}.
    *
    * <b>Внимание:<b>Использование класса запрещено, начиная с версии веб-фреймворка WS 3.7.5.100 он будет удалён.
    * Для использования функций класса "Core/helpers/helpers" Вам необходимо подключить конкретный класс из приведённого выше списка.
    * @class Core/helpers/helpers
    * @public
    * @author Мальцев А.А.
    * @deprecated
    */
   var Helpers = {};

   function copyFunctions(from) {
       Object.keys(from).forEach( function(name){
           Helpers[name] = from[name];
       });
   }

    copyFunctions(unrelated);
    copyFunctions(colHelpers);
    copyFunctions(mkupHelpers);
    copyFunctions(fHelpers);
    copyFunctions(dateHelpers);
    copyFunctions(domControlsHelpers);
    copyFunctions(fastHelpers);
    copyFunctions(genHelpers);
    copyFunctions(strHelpers);
    copyFunctions(transHelpers);
    copyFunctions(eventHelpers);
    copyFunctions(addHelpers);
    copyFunctions(dAddHelpers);
    copyFunctions(cDebug);
    copyFunctions(cInstance);

   return Helpers;
});