define('Core/helpers/markup-helpers', [
   'Core/Serializer',
   'Core/helpers/Hcontrol/configStorage',
   'Core/helpers/Hcontrol/variableStorage',
   'Core/markup/parse'
], function(Serializer, configStorage, variableStorage, parseMarkup) {

   /**
    * Перенес этот код из файла Control.compatible сюда
    * Для того, чтобы в режиме работы без слоя совместимости у нас работала функция wsControl()
    */
   if (typeof(jQuery) !== 'undefined') {
      (function( $ ) {
         $.fn.wsControl = function() {
            var control = null,
               element;
            try {
               element = this[0];
               while (element) {
                  if (element.wsControl) {
                     control = element.wsControl;
                     break;
                  }
                  element = element.parentNode;
               }
            }
            catch(e) {}
            return control;
         };
      })( jQuery );
   }

   //MOVE_TO ШИПИН

    /**
     * @class Core/helpers/markup-helpers
     * @public
     * @deprecated
     * @author Мальцев А.А.
     * @deprecated
     */
   var markup_helpers = /** @lends  Core/helpers/markup-helpers.prototype */ {
      getVarStorage: variableStorage.getValue,
      clearVarStorage: variableStorage.clear,
      encodeCfgAttr: configStorage.pushValue,
      decodeCfgAttr: configStorage.getValue,
      removeConfigStringDataFromStorage: configStorage.deleteString,
      getFuncFromDeclaration: Serializer.getFuncFromDeclaration,
      mergeConfigStorage: configStorage.merge,
      getConfigStorage: configStorage.getData,
      clearConfigStorage: configStorage.clear,
      parseMarkup: parseMarkup
   };

    variableStorage.init();

   return markup_helpers;
});