define('Core/helpers/transport-helpers', [
   'Core/deprecated',
   'Transport/prepareGetRPCInvocationURL',
   'Deprecated/helpers/transport-helpers'
], function(cDeprecated, prepareGetRPCInvocationURL, deprecatedHelpers) {

   var helperDeprecator = cDeprecated.callNextWrapper;
   var getHelpersDeprecatorWrapper = function (helperName, newName) {
      return function () {
         cDeprecated.showInfoLog('Хелпер Core/helpers/transport-helpers::' + helperName + ' помечен как deprecated и будет удален в 3.18.' + (newName ? ' Подключите явно ' + newName + ', чтобы им пользоваться.' : ''));
      };
   };
    /**
     * @class Core/helpers/transport-helpers
     * @public
     * @author Мальцев А.А.
     * @deprecated
     */
   var transHelpers = /** @lends  Core/helpers/transport-helpers.prototype */{
      jsonRpcPreparePacket: helperDeprecator(deprecatedHelpers.jsonRpcPreparePacket, function () {
         cDeprecated.showInfoLog('Хелпер $ws.helpers.jsonRpcPreparePacket помечен как deprecated и будет удален в 3.18. Подключите явно Transport/RPCJSON и используйте соответствующий метод');
      }),
      prepareSorting: helperDeprecator(deprecatedHelpers.prepareSorting, getHelpersDeprecatorWrapper('prepareSorting')),
      prepareGetRPCInvocationURL: helperDeprecator(prepareGetRPCInvocationURL, getHelpersDeprecatorWrapper('prepareGetRPCInvocationURL', 'Transport/prepareGetRPCInvocationURL')),
      fetchFile: helperDeprecator(deprecatedHelpers.fetchFile, getHelpersDeprecatorWrapper('fetchFile')),
      newRecordSet: helperDeprecator(deprecatedHelpers.newRecordSet, getHelpersDeprecatorWrapper('newRecordSet'))
   };

   return transHelpers;
});