/**
 * Created by tm.baeva on 04.12.13.
 */
/**
 * Created with JetBrains PhpStorm.
 * User: tm.baeva
 * Date: 21.04.13
 * Time: 21:59
 * To change this template use File | Settings | File Templates.
 */
define('Deprecated/Controls/DialogSelector/DialogSelector', [
   "Core/core-extend",
   "Deprecated/Controls/DialogSelector/Selector",
   "Lib/Control/Dialog/Dialog"
],
   function(cExtend, selectorConfig, Dialog) {

   'use strict';

   /**
    * Модальный диалог выбора из справочника
    *
    * Нужен для осуществления выбора связанной записи(используется полем связи).
    * В шаблоне этого диалога должен быть браузер - выборка из которой задаем связь.
    * Желательно, чтобы браузер был только один. Если их будет несколько то все нижеописанное применится только к первому.
    * Диалог переводит браузер в режим выбора. В таком режиме по нажатию Enter или ctrl + Enter отмеченные записи или в случае их отсутствия текущая запись уходят в поле связи.
    * @public
    * @class Deprecated/Controls/DialogSelector/DialogSelector
    * @author Крайнов Д.О.
    * @extends Lib/Control/Dialog/Dialog
    * @deprecated Используйте класс {@link SBIS3.CONTROLS.Action.SelectorAction}.
    */
   /**
    * @event Deprecated/Controls/DialogSelector/DialogSelector#onChange событие, происходящее при выборе значения в браузере
    * @param {Core/EventObject} eventObject Дескриптор события.
    * @param {Array} records Массив выбраных записей
    */
   var DialogSelector = cExtend.mixin(Dialog, selectorConfig);
       /**
        * @cfg {Boolean} Разрешить выбор нескольких значений
        * @name Deprecated/Controls/DialogSelector/DialogSelector#multiSelect
        * @example
        * <pre>
        *     <option name="multiSelect">true</option>
        * </pre>
        */
       /**
        * @cfg {String} Тип выбираемых записей
        * @name Deprecated/Controls/DialogSelector/DialogSelector#selectionType
        * Опция задаёт тип записей, которые можно выбирать в данном представлении данных.
        * @example
        * <pre>
        *     <option name="selectionType">node</option>
        * </pre>
        * @variant node Только узлы
        * @variant leaf Только листья
        * @variant all Узлы и листья, по умолчанию
        */

   return DialogSelector;
});
