/**
 * Created by tm.baeva on 09.12.13.
 */
/**
 * Created by tm.baeva on 04.12.13.
 */
define('Deprecated/Controls/DialogSelector/FloatAreaSelector', [
   "Core/core-extend",
   "Deprecated/Controls/DialogSelector/Selector",
   "Lib/Control/FloatArea/FloatArea"
],
   function(cExtend, selectorConfig, FloatArea) {

   'use strict';

   /**
    * Всплывающая панель для выбора значений.
    * @description file FloatAreaSelector.md
    * @public
    * @author Крайнов Д.О.
    * @class Deprecated/Controls/DialogSelector/FloatAreaSelector
    * @extends Lib/Control/FloatArea/FloatArea
    * @control
    * @deprecated Используйте класс {@link SBIS3.CONTROLS.Action.SelectorAction}.
    */
    /**
     * @event Deprecated/Controls/DialogSelector/FloatAreaSelector#onChange событие, происходящее при выборе значения в браузере
     * @param {Core/EventObject} eventObject описание в классе Core/Abstract
     * @param {Array} records Массив выбраных записей
     */
   var FloatAreaSelector = cExtend.mixin(FloatArea, selectorConfig);
       /**
        * @cfg {Boolean} Устанавливает режим множественного выбора элементов коллекции.
        * @name Deprecated/Controls/DialogSelector/FloatAreaSelector#multiSelect
        * @remark
        * * true Установлен режим множественного выбора значений.
        * * false Установлен режим единичного выбора значений.
        * Опция применяется только в представлениях данных на диалоге выбора.
        * Режим множественного выбора - это режим работы контрола, который позволяет выбрать несколько элементов коллекции.
        * Отображение множественного выбора в табличном представлении - это некоторое количество записей таблицы, выделенных флагами:
        * ![](/FloatAreaSelector-03.png)
        *
        * @example
        * <pre>
        *     <option name="multiSelect">true</option>
        * </pre>
        */
       /**
        * @cfg {String} Устанавливает тип выбираемых записей в связанном представлении данных.
        * @name Deprecated/Controls/DialogSelector/FloatAreaSelector#selectionType
        * @remark
        * Опция задаёт тип записей иерархических структур, которые можно выбирать в данном представлении данных. К таким типам относят узлы и листья.
        * Подробно они описаны в документации по иерархическим структурам:
        * * {@link https://wi.sbis.ru/doc/platform/developmentapl/workdata/structure/vocabl/tabl/relations/#hierarchy "Иерархия"}
        * @example
        * <pre>
        *     <option name="selectionType">node</option>
        * </pre>
        * @variant node Только узлы
        * @variant leaf Только листья
        * @variant all Узлы и листья, по умолчанию
        */

   return FloatAreaSelector;
});
