/**
 * Модуль "Компонент кнопка".
 *
 * @description
 */
define('Deprecated/Controls/LinkButton/LinkButton', ['Deprecated/Controls/Button/Button', 'css!Deprecated/Controls/LinkButton/LinkButton'], function(Button) {

   'use strict';

   /**
    * Кнопка-ссылка
    *
    * @class Deprecated/Controls/LinkButton/LinkButton
    * @extends Deprecated/Controls/Button/Button
    * @author Крайнов Д.О.
    * @control
    * @public
    * @initial
    * <component data-component="Deprecated/Controls/LinkButton/LinkButton">
    *    <option name="caption" value="Кнопка как ссылка"></option>
    * </component>
    * @category Button
    * @designTime actions /design/design
    * @deprecated Используйте классы {@link SBIS3.CONTROLS.Link} или {@link SBIS3.CONTROLS.MenuLink}.
    */
   var LinkButton = Button.extend(/** @lends Deprecated/Controls/LinkButton/LinkButton.prototype */{
      $protected:{
         _options:{
            /**
             * @cfg {String} Ссылка, которая откроется при клике на кнопку-ссылку
             * Изменяется методом {@link setOpenLink}
             *
             */
            openLink : '',
            renderStyle : 'asLink'
         }
      },
      getOpenLink: function(){
         return this._options.openLink;
      },
      setOpenLink: function(openLink){
         this._options.openLink = openLink;
         this._bodyContainer.attr('href', openLink);
      }
   });

   return LinkButton;

});
