define('Lib/Control/FileButton/design/DesignPlugin', [
   "Lib/Control/FileButton/FileButton"
], function(FileButton) {
   //endregion

   /**
    * @class FileButton.DesignPlugin
    * @extends FileButton
    * необходим для изменения опции renderStyle
    * @plugin
    */
   FileButton.DesignPlugin = FileButton.extendPlugin({
      setRenderStyle: function(renderStyle) {
         this._options.renderStyle = renderStyle;
         this._container
            .toggleClass('ws-button-classic', renderStyle === 'classic')
            .toggleClass('ws-button-link', renderStyle === 'asLink');
         this._container.empty();
         var template = $(this._dotTplFn(this._options)).children();
         this._container.append(template);
         this._setRenderStyleClass();
         this._redraw();
      }
   });
});