/// <amd-module name="Lib/File/Attach/Option/Getters/Dialogs" />
define("Lib/File/Attach/Option/Getters/Dialogs", ["require", "exports", "tslib", "Lib/File/Attach/Option/ResourceGetter"], function (require, exports, tslib_1, ResourceGetter) {
    "use strict";
    var GETTER_LINK = "js!SBIS3.Plugin/components/Extensions/Integration/FileGetter/DialogsGetter";
    var GETTER_TYPE = "DialogsGetter";
    /**
     * Класс конфигурации IResourceGetter для получения файлов из диалогового окна СБИС Плагина, передаваемый в SbisAttach
     * @class
     * @name Lib/File/Attach/Option/Getters/Dialogs
     * @public
     * @author Заляев А.В.
     */
    var Dialogs = /** @class */ (function (_super) {
        tslib_1.__extends(Dialogs, _super); /** @lends Lib/File/Attach/Option/Getters/Dialogs.prototype*/
        /**
         * @param {*} [options] Параметры вызова конструктора
         * @constructor
         * @see Lib/File/ResourceGetter/IResourceGetterBase
         */
        function Dialogs(options) {
            return _super.call(this, GETTER_LINK, GETTER_TYPE, options || {}) || this;
        }
        return Dialogs;
    }(ResourceGetter /** @lends Lib/File/Attach/Option/Getters/Dialogs.prototype*/));
    return Dialogs;
});
