/// <amd-module name="Lib/File/Attach/Option/Getters/PhotoCam" />

import ResourceGetter = require("Lib/File/Attach/Option/ResourceGetter");

const GETTER_LINK = "Lib/File/ResourceGetter/PhotoCam";
const GETTER_TYPE = "PhotoCam";

/**
 * Класс конфигурации IResourceGetter для получения снимков с камеры, передаваемый в SbisAttach
 * @class
 * @name Lib/File/Attach/Option/Getters/PhotoCam
 * @public
 * @author Заляев А.В.
 */
class PhotoCam extends ResourceGetter /** @lends Lib/File/Attach/Option/Getters/PhotoCam.prototype*/{
    /**
     * @param {*} [options] Параметры вызова конструктора
     * @constructor
     * @see Lib/File/ResourceGetter/IResourceGetterBase
     */
    constructor (options?: any) {
        super (GETTER_LINK, GETTER_TYPE, options || {});
    }
}
export = PhotoCam;