/// <amd-module name="Lib/File/Attach/Option/Getters/Scanner" />
define("Lib/File/Attach/Option/Getters/Scanner", ["require", "exports", "tslib", "Lib/File/Attach/Option/ResourceGetter"], function (require, exports, tslib_1, ResourceGetter) {
    "use strict";
    var GETTER_LINK = "js!SBIS3.Plugin/components/Extensions/Integration/FileGetter/ScannerGetter";
    var GETTER_TYPE = "ScannerGetter";
    /**
     * Класс конфигурации IResourceGetter для получения сканов, передаваемый в SbisAttach
     * @class
     * @name Lib/File/Attach/Option/Getters/Scanner
     * @public
     * @author Заляев А.В.
     */
    var Scanner = /** @class */ (function (_super) {
        tslib_1.__extends(Scanner, _super); /** @lends Lib/File/Attach/Option/Getters/Scanner.prototype*/
        /**
         * @param {*} [options] Параметры вызова конструктора
         * @constructor
         * @see Lib/File/ResourceGetter/IResourceGetterBase
         */
        function Scanner(options) {
            return _super.call(this, GETTER_LINK, GETTER_TYPE, options || {}) || this;
        }
        return Scanner;
    }(ResourceGetter /** @lends Lib/File/Attach/Option/Getters/Scanner.prototype*/));
    return Scanner;
});
