define("Lib/ServerEvent/class/deliver/PageEventDeliver", ["require", "exports"], function (require, exports) {
    "use strict";
    /**
     * Доставщик событий только по текущей странице
     */
    var PageEventDeliver = /** @class */ (function () {
        function PageEventDeliver(notifier) {
            this.notifier = notifier;
        }
        PageEventDeliver.prototype.deliver = function (channelName, eventName, rawData) {
            this.notifier.fire(channelName, eventName, rawData);
        };
        PageEventDeliver.prototype.destroy = function () {
        };
        return PageEventDeliver;
    }());
    return PageEventDeliver;
});
