/// <amd-module name="Lib/ServerEvent/class/logger/ConnectWatchDog" />
/**
 * @author Санников К.А.
 */
"use strict";
import {SEB} from "../../interfaces";

class ConnectWatchDog implements SEB.IWatchDog {
    logStomp(message: SEB.StompMessageData) {
    }

    logEvent(channelName: string, eventName: string, data: any) {
    }

    logConnect(data) {
        console.log(`[STOMP][Connect][${new Date().toLocaleString()}]`, data);
    }

    logDisconnect(e) {
        console.log(`[STOMP][Disconnect][${new Date().toLocaleString()}]`, e);
    }
}

export = ConnectWatchDog;