import Writer = require('Lib/ServerEvent/native/EventStorage/Writer');
import Reader = require('Lib/ServerEvent/native/EventStorage/Reader');
/**
 * @class Lib/ServerEvent/native/EventStorage/Connector
 * @memberOf module:ServerEvent.native.EventStorage
 */
declare class Connector {
    private db;
    static DB_NAME: string;
    static STORE_NAME: string;
    static connect(): Promise<Connector>;
    constructor(db: IDBDatabase);
    /**
     * @return {Lib/ServerEvent/native/EventStorage/Writer}
     */
    getWriter(): Writer;
    /**
     * @return {Lib/ServerEvent/native/EventStorage/Reader}
     */
    getReader(): Reader;
}
export = Connector;
