declare class Writer
{
    static GC_INTERVAL: 5000;
    constructor(db: IDBDatabase, storeName: string, storeKey: string);
    write(message: Stomp.Message)
    createStore()
}

declare class Reader
{
    constructor(db: IDBDatabase, storeName: string, storeKey: string);
    query(channelFilter?: string|RegExp): Promise<Object[]>;
}

declare class Connector {
    static DB_NAME: "sbis.seb";
    static STORE_NAME: "events";
    static STORE_KEY: "timestamp";

    static connect(): Promise<Connector>;
    constructor(db: IDBDatabase);
    getWriter(): Writer;
    getReader(): Reader;
}

declare class ConnectorIE {
    static DB_NAME: "sbis.seb";
    static STORE_NAME: "events";
    static STORE_KEY: "timestamp";

    static connect();
    constructor(db: IDBDatabase);
    getWriter(): Writer;
    getReader(): Reader;
}