/**
 * Created by dv.zuev on 07.08.2017.
 */
define('js!WSTests/unit/tmpl/sync-tests/context/skipContextMid', [
   'Core/Control',
   'tmpl!WSTests/unit/tmpl/sync-tests/context/skipContextMid',
   'js!WSTests/unit/tmpl/sync-tests/context/contextField2'
], function (Control, tmpl, contextField2) {
   'use strict';


   var testModule = Control.extend({
      _template: tmpl,
      ctxValue: null,
      constructor: function (cfg) {
        testModule.superclass.constructor.call(this, cfg);
        this.ctxValue = new contextField2();
      },
      _getChildContext: function () {
         return {midField: this.ctxValue};
      },
      setContextValue: function () {
         this.ctxValue.setData();
      }
   });

   return testModule;
});
