/**
 * Created by dv.zuev on 07.08.2017.
 */
define('js!WSTests/unit/tmpl/sync-tests/context/top', [
   'Core/Control',
   'tmpl!WSTests/unit/tmpl/sync-tests/context/top',
   'js!WSTests/unit/tmpl/sync-tests/context/contextField'
], function (Control, tmpl, contextField) {
   'use strict';

   var testModule = Control.extend({
      _template: tmpl,
      ctxField: new contextField(),
      optionValue: 'optionValue1',
      _getChildContext: function(){
         return { field: this.ctxField };
      },
      setContextValue: function(val) {
        this.ctxField.setData();
        this.optionValue = "optionValue2";
        this._forceUpdate();
      }
   });

   return testModule;
});
