/**
 * Created by dv.zuev on 07.08.2017.
 */
define('js!WSTests/unit/tmpl/sync-tests/piledAsync', [
   'Core/Control',
   'tmpl!WSTests/unit/tmpl/sync-tests/piledAsync',
   'Core/Deferred'
], function (Control, tmpl, Deferred) {
   'use strict';

   var testModule = Control.extend({
      _template: tmpl,
      text: 'root async test',
      _beforeMount: function (options) {
         var def = new Deferred();
         setTimeout(function () {
            def.callback({
               tree: {
                  leaf: '111'
               }
            });
         }, 100);
         return def;
      }
   });

   return testModule;
});
