/**
 * Test control
 * controlNodes: [c1, c2, c3]
 * eventProperties: [f2, f3]
 * c3 notifies click and customEvent
 * Created by dv.zuev on 07.08.2017.
 */
define('js!WSTests/unit/tmpl/sync-tests/vdomEvents/stopPropagation/multipleControlNodes1', [
   'Core/Control',
   'tmpl!WSTests/unit/tmpl/sync-tests/vdomEvents/stopPropagation/multipleControlNodes1'
], function (Control, tmpl) {
   'use strict';

   var testModule = Control.extend({
      _template: tmpl,
      text: '',
      myClickUp: function(eventObject){
         this.text = "control 1 handled";
         return 'abc';
      },
      myCustomEventUp: function(event, text) {
         this.text = text;
         return 'abc';
      }
   });

   return testModule;
});
